/* ccgo: gotalk.cc
 *
 * GoTalk class definition
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include "gotalk.hh"

using namespace std;

GoTalk::GoTalk()
{
	Gtk::ScrolledWindow * s;
	text.show();
	text.set_usize(-1, text.get_style()->get_font().char_height('|') * 5);
	s = manage(new Gtk::ScrolledWindow);
	s->set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
	s->add(text);
	s->show();
	pack_start(* s);
	line.show();
	pack_start(line, false);
	line.activate.connect(slot(this, & GoTalk::do_line_enter));

	ctx_moves = text.get_context();
	ctx_moves.set_foreground(Gdk_Color("green"));
	ctx_message = text.get_context();
	ctx_message.set_foreground(Gdk_Color("red"));
}

GoTalk::~GoTalk()
{
}

void GoTalk::add_text(const string & s, TextType t)
{
	switch(t) {
	case TT_NORMAL:
		text.insert(s + "\n");
		break;
	case TT_MOVES:
		text.insert(ctx_moves, s + "\n");
		break;
	case TT_MESSAGE:
		text.insert(ctx_message, s + "\n");
		break;
	}
}

void GoTalk::do_line_enter()
{
	line_enter.emit(line.get_text());
	text.insert("(me): ");
	text.insert(line.get_text() + "\n");
	line.set_text("");
}
